//+------------------------------------------------------------------+
//|                                                     indclass.mqh |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+

struct indtest
{
   double IndicatorBuffer[], testbuffer[];
   int IndicatorHandle;
   int i, Start, Limit;
   int window;
   indtest();
   void PopulateBuffer();
   void processbuffer();
   ~indtest(){}
};

indtest::indtest()
{
IndicatorHandle = 0;
Start = 3;
Limit = 15;
i = Start;
window = 1000;
}

indtest::PopulateBuffer(void)
{
   IndicatorRelease(IndicatorHandle);

   if(i<Limit)
      {
      IndicatorHandle = iMA(_Symbol, _Period, i,0,MODE_EMA, PRICE_CLOSE);
      ArrayFree(IndicatorBuffer);
      ArrayResize(IndicatorBuffer,window+1);
      
      while(CopyBuffer(IndicatorHandle,0,0,window+1,IndicatorBuffer)<window) 
         Sleep(20);
       
      Print("handle = ", IndicatorHandle, " and buffer from 0 - ", IndicatorBuffer[0], ","
      ,IndicatorBuffer[1],",",IndicatorBuffer[2],",",IndicatorBuffer[3]); 
      processbuffer();
      i++;
      }
   else
      i = Start;

}

indtest::processbuffer(void)
{
   ArrayResize(testbuffer,window+1);
   for(int j = 0; j < window; j++)
      {
      
      testbuffer[j] = IndicatorBuffer[j];
      }
      
}



void RUNTEST()
{
indtest testobject;

   for(int i = 0; i < 10000; i++)
      {
      testobject.PopulateBuffer();
      //Print("i = ", i);
      Sleep(2);
      }

}

